package travelplanner;

import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;

import de.iflow.components.IFlowService;

public class Airline extends IFlowService {

	private static Airline instance;

	private Airline() {
	}

	public static Airline getInstance() {
		if (instance == null) {
			instance = new Airline();
		}
		return instance;
	}

	/*
	 * Each action should be static and should return a Result,
	 * else a
	 * "Compilation error"
	 * "Cannot use a method returning Unit as an Handler"
	 * occurs
	 */
	public static Result index() {
		return index("IFlow - Airline");
	}

	/*
	 * GetFlightOffers
	 */

	private static List<FlightOffer> flightOffers = new ArrayList<FlightOffer>();

	public static Result resultForGetFlightOffers;

	//proxy
	public static Result getFlightOffers(String destination) {
		RequestData requestData = new RequestData();
		requestData.setDestination(destination);
		getInstance().getFlightOffers(new GetFlightOffers(requestData)); //Airline a = new Airline(); // or getInstance()
		return resultForGetFlightOffers;
	}

	public void getFlightOffers(GetFlightOffers getFlightOffers) {
		RequestData requestData = getFlightOffers.getRequestData();
		List<FlightOffer> filteredFlightOffers = Manual.filterOffers(requestData, flightOffers);
		TravelAgency.getInstance().retFlightOffers(new RetFlightOffers(filteredFlightOffers));
	}

	/*
	 * BookFlightOffer
	 */

	public static Result resultForBookFlightOffer;

	//proxy
	public static Result bookFlightOffer() {
		BookFlightOffer b = new Gson().fromJson(getJsonAsString(), BookFlightOffer.class);
		getInstance().bookFlightOffer(b);
		return resultForBookFlightOffer;
	}

	public void bookFlightOffer(BookFlightOffer message) {
		int id = message.getId();
		CreditCardData ccd_decl = message.getCcd();
		Manual.processBooking(id, ccd_decl);
		TravelAgency.getInstance().payCommission(new PayCommission(id));
	}

	public void okPayCommission(OkPayCommission message) {
		TravelPlanner.getInstance().okConfirmBooking(new OkConfirmBooking());
	}
}
