package travelplanner;

import de.iflow.components.IFlowApplication;

public class CreditCardCenter extends IFlowApplication {

	private CreditCardData ccd = new CreditCardData(1234567890);

	private static CreditCardCenter instance;

	// constructor can't be private in android
	public CreditCardCenter() {
		// Activity is automatically called/created by the Android Framework
		// set reference to object with keyword this
		instance = this;
	}

	// then it's not really a singleton pattern...
	public static CreditCardCenter getInstance() {
		// in android instance won't be null, if activity is created
		if (instance == null) {
			instance = new CreditCardCenter();
		}
		return instance;
	}

	/*
	 * Implement abstract methods from inherited abstract parent
	 */

	@Override
	public void init() {
	}

	@Override
	protected void storeData() {
	}

	@Override
	protected void restoreData() {
	}

	@Override
	protected void handleIntentExtras() {
		if (getIFlowMessage("ReleaseCCD", ReleaseCCD.class) != null) {
			ReleaseCCD message = (ReleaseCCD) getIFlowMessage("ReleaseCCD", ReleaseCCD.class);
			releaseCCD(message);
		}
	}

	/*
	 * CreditCardCenter
	 */

	public void releaseCCD(ReleaseCCD message) {
		Airline airline = message.getAirline();
		User.getInstance().confirmForRetConfirmation(new ConfirmRelease(ccd, airline));

	}

	public void retConfirmation(RetConfirmation message) {
		CreditCardData ccd_decl = Declassify.declassify(ccd);
		TravelPlanner.getInstance().declassifiedCCD(new DeclassifiedCCD(ccd_decl));
	}

}
