package travelplanner;

import com.google.gson.Gson;

import de.iflow.components.IFlowService;

public class TravelAgency extends IFlowService {

	private static TravelAgency instance;

	private TravelAgency() {

	}

	// Singleton Pattern
	public static TravelAgency getInstance() {
		if (instance == null) {
			instance = new TravelAgency();
		}
		return instance;
	}

	/*
	 * Each action should be static and should return a Result,
	 * else a
	 * "Compilation error"
	 * "Cannot use a method returning Unit as an Handler"
	 * occurs
	 */

	public static Result index() {
		return index("IFlow - TravelAgency");
	}

	/*
	 * GetFlightOffers
	 */

	public static Result resultForGetFlightOffers;

	// proxy
	public static Result getFlightOffers(String destination) {
		RequestData requestData = new RequestData();
		requestData.setDestination(destination);
		getInstance().getFlightOffers(new GetFlightOffers(requestData));
		return resultForGetFlightOffers;
	}

	public void getFlightOffers(GetFlightOffers inmsg) {
		RequestData requestData = inmsg.getRequestData();
		Airline.getInstance().getFlightOffers(new GetFlightOffers(requestData));
	}

	public void retFlightOffers(RetFlightOffers message) {
		TravelPlanner.getInstance().retFlightOffers(message);
	}

	/*
	 * PayCommission
	 */

	public static Result resultForPayCommission;

	// proxy
	public static Result payCommission() {
		PayCommission p = new Gson().fromJson(getJsonAsString(), PayCommission.class);
		getInstance().payCommission(p);
		return resultForPayCommission;
	}

	public void payCommission(PayCommission message) {
		Airline.getInstance().okPayCommission(new OkPayCommission());
	}

}
