package travelplanner;

import java.util.List;

import de.iflow.components.IFlowUser;
import de.iflow.data.IFlowData;
import de.iflow.views.IFlowConfirmFragment;
import de.iflow.views.IFlowConfirmFragment.ConfirmListener;
import de.iflow.views.IFlowGetInputFragment;
import de.iflow.views.IFlowGetInputFragment.InputListener;
import de.iflow.views.IFlowGetSingleSelectionFragment;
import de.iflow.views.IFlowGetSingleSelectionFragment.SingleSelectionListener;

public class User extends IFlowUser {

	private static User instance;

	public static User getInstance() {
		if (instance == null) {
			instance = new User();
		}
		return instance;
	}

	/*
	 * TravelPlanner
	 */

	public void getInputForRetInput() {
		IFlowGetInputFragment f = showGetInputFragment(TravelPlanner.getInstance(), "fr_get_input", new String[] { "fr_get_input_destination" }, "fr_get_input_ok_button");
		f.setInputListener(getInputListenerForRetInput);
		f.simulateUserInteraction();
	}

	private InputListener getInputListenerForRetInput = new InputListener() {

		@Override
		public void onInput(String[] inputOfEditTexts) {
			RequestData requestData = new RequestData();
			requestData.setDestination(inputOfEditTexts[0]);
			TravelPlanner.getInstance().retInput(new RetInput(requestData));
		}

	};

	public void getSingleSelectionForRetSingleSelection(GetSingleSelection getSingleSelectionMessage) {
		List<IFlowData> data = (List) getSingleSelectionMessage.getFlightOffers();

		IFlowGetSingleSelectionFragment f = showGetSingleSelectionFragment(TravelPlanner.getInstance(), data);
		f.setSingleSelectionListener(getSingleSelectionListenerForRetSingleSelection);
		f.simulateUserInteraction();
	}

	private SingleSelectionListener getSingleSelectionListenerForRetSingleSelection = new SingleSelectionListener() {

		@Override
		public void onSingleSelection(IFlowData singleSelection) {
			FlightOffer flightOffer = (FlightOffer) singleSelection;
			TravelPlanner.getInstance().retSingleSelection(new RetSingleSelection(flightOffer));

		}

	};

	public void ok(Ok ok) {
		showOkFragment(TravelPlanner.getInstance());
	}

	/*
	 * CreditCardCenter
	 */
	public void confirmForRetConfirmation(ConfirmRelease message) {
		CreditCardData ccd = message.getCcd();
		Airline airline = message.getAirline();
		IFlowConfirmFragment f = showConfirmFragment(CreditCardCenter.getInstance(),
			"Release Credit Card Data?");
		f.setConfirmListener(confirmListenerForRetConfirmation);
		f.simulateUserInteraction();
	}

	private ConfirmListener confirmListenerForRetConfirmation = new ConfirmListener() {

		@Override
		public void onConfirm() {
			CreditCardCenter.getInstance().retConfirmation(new RetConfirmation());
		}
	};

}
